Loading...
Searching...
No Matches
irr::scene::ICameraSceneNode Class Referenceabstract

Scene Node which is a (controlable) camera. More...

`#include <ICameraSceneNode.h>`

Inheritance diagram for irr::scene::ICameraSceneNode:

## Public Member Functions

| ICameraSceneNode (ISceneNode *parent, ISceneManager *mgr, s32 id, const core::vector3df &position=core::vector3df(0, 0, 0), const core::vector3df &rotation=core::vector3df(0, 0, 0), const core::vector3df &scale=core::vector3df(1.0f, 1.0f, 1.0f))
| Constructor.
virtual void | bindTargetAndRotation (bool bound)=0
| Binds the camera scene node's rotation to its target position and vice vera, or unbinds them.
virtual void | deserializeAttributes (io::IAttributes *in, io::SAttributeReadWriteOptions *options=0)
| Reads attributes of the camera node.
virtual f32 | getAspectRatio () const =0
| Gets the aspect ratio of the camera.
virtual f32 | getFarValue () const =0
| Gets the value of the far plane of the camera.
virtual f32 | getFOV () const =0
| Gets the field of view of the camera.
virtual f32 | getNearValue () const =0
| Gets the value of the near plane of the camera.
virtual const core::matrix4 & | getProjectionMatrix () const =0
| Gets the current projection matrix of the camera.
virtual const core::vector3df & | getTarget () const =0
| Gets the current look at target of the camera.
virtual bool | getTargetAndRotationBinding (void) const =0
| Queries if the camera scene node's rotation and its target position are bound together.
virtual const core::vector3df & | getUpVector () const =0
| Gets the up vector of the camera.
virtual const SViewFrustum * | getViewFrustum () const =0
| Get the view frustum.
virtual const core::matrix4 & | getViewMatrix () const =0
| Gets the current view matrix of the camera.
virtual const core::matrix4 & | getViewMatrixAffector () const =0
| Get the custom view matrix affector.
virtual bool | isInputReceiverEnabled () const =0
| Checks if the input receiver of the camera is currently enabled.
virtual bool | isOrthogonal () const
| Checks if a camera is orthogonal.
virtual bool | OnEvent (const SEvent &event)=0
| It is possible to send mouse and key events to the camera.
virtual void | serializeAttributes (io::IAttributes *out, io::SAttributeReadWriteOptions *options=0) const
| Writes attributes of the camera node.
virtual void | setAspectRatio (f32 aspect)=0
| Sets the aspect ratio (default: 4.0f / 3.0f).
virtual void | setFarValue (f32 zf)=0
| Sets the value of the far clipping plane (default: 2000.0f).
virtual void | setFOV (f32 fovy)=0
| Sets the field of view (Default: PI / 2.5f).
virtual void | setInputReceiverEnabled (bool enabled)=0
| Disables or enables the camera to get key or mouse inputs.
virtual void | setNearValue (f32 zn)=0
| Sets the value of the near clipping plane. (default: 1.0f).
virtual void | setProjectionMatrix (const core::matrix4 &projection, bool isOrthogonal=false)=0
| Sets the projection matrix of the camera.
virtual void | setRotation (const core::vector3df &rotation)=0
| Sets the rotation of the node.
virtual void | setTarget (const core::vector3df &pos)=0
| Sets the look at target of the camera.
virtual void | setUpVector (const core::vector3df &pos)=0
| Sets the up vector of the camera.
virtual void | setViewMatrixAffector (const core::matrix4 &affector)=0
| Sets a custom view matrix affector.
Public Member Functions inherited from irr::scene::ISceneNode
| ISceneNode (ISceneNode *parent, ISceneManager *mgr, s32 id=-1, const core::vector3df &position=core::vector3df(0, 0, 0), const core::vector3df &rotation=core::vector3df(0, 0, 0), const core::vector3df &scale=core::vector3df(1.0f, 1.0f, 1.0f))
| Constructor.
virtual | ~ISceneNode ()
| Destructor.
virtual void | addAnimator (ISceneNodeAnimator *animator)
| Adds an animator which should animate this node.
virtual void | addChild (ISceneNode *child)
| Adds a child to this scene node.
virtual ISceneNode * | clone (ISceneNode *newParent=0, ISceneManager *newManager=0)
| Creates a clone of this scene node and its children.
virtual core::vector3df | getAbsolutePosition () const
| Gets the absolute position of the node in world coordinates.
virtual const core::matrix4 & | getAbsoluteTransformation () const
| Get the absolute transformation of the node. Is recalculated every OnAnimate()-call.
const core::list< ISceneNodeAnimator * > & | getAnimators () const
| Get a list of all scene node animators.
u32 | getAutomaticCulling () const
| Gets the automatic culling state.
virtual const core::aabbox3d< f32 > & | getBoundingBox () const =0
| Get the axis aligned, not transformed bounding box of this node.
const core::list< ISceneNode * > & | getChildren () const
| Returns a const reference to the list of all children.
virtual s32 | getID () const
| Get the id of the scene node.
virtual video::SMaterial & | getMaterial (u32 num)
| Returns the material based on the zero based index i.
virtual u32 | getMaterialCount () const
| Get amount of materials used by this scene node.
virtual const c8 * | getName () const
| Returns the name of the node.
scene::ISceneNode * | getParent () const
| Returns the parent of this scene node.
virtual const core::vector3df & | getPosition () const
| Gets the position of the node relative to its parent.
virtual core::matrix4 | getRelativeTransformation () const
| Returns the relative transformation of the scene node.
virtual const core::vector3df & | getRotation () const
| Gets the rotation of the node relative to its parent.
virtual const core::vector3df & | getScale () const
| Gets the scale of the scene node relative to its parent.
virtual ISceneManager * | getSceneManager (void) const
| Retrieve the scene manager for this node.
virtual const core::aabbox3d< f32 > | getTransformedBoundingBox () const
| Get the axis aligned, transformed and animated absolute bounding box of this node.
virtual ITriangleSelector * | getTriangleSelector () const
| Returns the triangle selector attached to this scene node.
virtual ESCENE_NODE_TYPE | getType () const
| Returns type of the scene node.
u32 | isDebugDataVisible () const
| Returns if debug data like bounding boxes are drawn.
bool | isDebugObject () const
| Returns if this scene node is a debug object.
virtual bool | isTrulyVisible () const
| Check whether the node is truly visible, taking into accounts its parents' visibility.
virtual bool | isVisible () const
| Returns whether the node should be visible (if all of its parents are visible).
virtual void | OnAnimate (u32 timeMs)
| OnAnimate() is called just before rendering the whole scene.
virtual void | OnRegisterSceneNode ()
| This method is called just before the rendering process of the whole scene.
virtual void | remove ()
| Removes this scene node from the scene.
virtual void | removeAll ()
| Removes all children of this scene node.
virtual void | removeAnimator (ISceneNodeAnimator *animator)
| Removes an animator from this scene node.
virtual void | removeAnimators ()
| Removes all animators from this scene node.
virtual bool | removeChild (ISceneNode *child)
| Removes a child from this scene node.
virtual void | render ()=0
| Renders the node.
void | setAutomaticCulling (u32 state)
| Enables or disables automatic culling based on the bounding box.
virtual void | setDebugDataVisible (u32 state)
| Sets if debug data like bounding boxes should be drawn.
virtual void | setID (s32 id)
| Sets the id of the scene node.
void | setIsDebugObject (bool debugObject)
| Sets if this scene node is a debug object.
void | setMaterialFlag (video::E_MATERIAL_FLAG flag, bool newvalue)
| Sets all material flags at once to a new value.
void | setMaterialTexture (u32 textureLayer, video::ITexture *texture)
| Sets the texture of the specified layer in all materials of this scene node to the new texture.
void | setMaterialType (video::E_MATERIAL_TYPE newType)
| Sets the material type of all materials in this scene node to a new material type.
virtual void | setName (const c8 *name)
| Sets the name of the node.
virtual void | setName (const core::stringc &name)
| Sets the name of the node.
virtual void | setParent (ISceneNode *newParent)
| Changes the parent of the scene node.
virtual void | setPosition (const core::vector3df &newpos)
| Sets the position of the node relative to its parent.
virtual void | setScale (const core::vector3df &scale)
| Sets the relative scale of the scene node.
virtual void | setTriangleSelector (ITriangleSelector *selector)
| Sets the triangle selector of the scene node.
virtual void | setVisible (bool isVisible)
| Sets if the node should be visible or not.
virtual void | updateAbsolutePosition ()
| Updates the absolute position based on the relative and the parents position.
Public Member Functions inherited from irr::IReferenceCounted
| IReferenceCounted ()
| Constructor.
virtual | ~IReferenceCounted ()
| Destructor.
bool | drop () const
| Drops the object. Decrements the reference counter by one.
const c8 * | getDebugName () const
| Returns the debug name of the object.
s32 | getReferenceCount () const
| Get the reference count.
void | grab () const
| Grabs the object. Increments the reference counter by one.
Public Member Functions inherited from irr::IEventReceiver
virtual | ~IEventReceiver ()
| Destructor.

## Protected Member Functions

void | cloneMembers (ICameraSceneNode *toCopyFrom)
Protected Member Functions inherited from irr::scene::ISceneNode
void | cloneMembers (ISceneNode *toCopyFrom, ISceneManager *newManager)
| A clone function for the ISceneNode members.
void | setSceneManager (ISceneManager *newManager)
Protected Member Functions inherited from irr::IReferenceCounted
void | setDebugName (const c8 *newName)
| Sets the debug name of the object.

## Protected Attributes

bool | IsOrthogonal
Protected Attributes inherited from irr::scene::ISceneNode
core::matrix4 | AbsoluteTransformation
| Absolute transformation of the node.
core::list< ISceneNodeAnimator * > | Animators
| List of all animator nodes.
u32 | AutomaticCullingState
| Automatic culling state.
core::list< ISceneNode * > | Children
| List of all children of this node.
u32 | DebugDataVisible
| Flag if debug data should be drawn, such as Bounding Boxes.
s32 | ID
| ID of the node.
bool | IsDebugObject
| Is debug object?
bool | IsVisible
| Is the node visible?
core::stringc | Name
| Name of the scene node.
ISceneNode * | Parent
| Pointer to the parent.
core::vector3df | RelativeRotation
| Relative rotation of the scene node.
core::vector3df | RelativeScale
| Relative scale of the scene node.
core::vector3df | RelativeTranslation
| Relative translation of the scene node.
ISceneManager * | SceneManager
| Pointer to the scene manager.
ITriangleSelector * | TriangleSelector
| Pointer to the triangle selector.

## Detailed Description

Scene Node which is a (controlable) camera.

The whole scene will be rendered from the cameras point of view. Because the ICameraScenNode is a SceneNode, it can be attached to any other scene node, and will follow its parents movement, rotation and so on.

Definition at line 23 of file ICameraSceneNode.h.

## Constructor & Destructor Documentation

## ICameraSceneNode()

irr::scene::ICameraSceneNode::ICameraSceneNode | ( | ISceneNode * | parent,
|  | ISceneManager * | mgr,
|  | s32 | id,
|  | const core::vector3df & | position = core::vector3df(0,0,0),
|  | const core::vector3df & | rotation = core::vector3df(0,0,0),
|  | const core::vector3df & | scale = core::vector3df(1.0f,1.0f,1.0f) )

inline

Constructor.

Definition at line 28 of file ICameraSceneNode.h.

References irr::scene::ISceneNode::ISceneNode(), and IsOrthogonal.

Referenced by cloneMembers().

## Member Function Documentation

## bindTargetAndRotation()

virtual void irr::scene::ICameraSceneNode::bindTargetAndRotation | ( | bool | bound | ) |

pure virtual

Binds the camera scene node's rotation to its target position and vice vera, or unbinds them.

When bound, calling setRotation() will update the camera's target position to be along its +Z axis, and likewise calling setTarget() will update its rotation so that its +Z axis will point at the target point. FPS camera use this binding by default; other cameras do not.

Parameters

  bound | True to bind the camera's scene node rotation and targetting, false to unbind them.

See also
  getTargetAndRotationBinding()

## cloneMembers()

void irr::scene::ICameraSceneNode::cloneMembers | ( | ICameraSceneNode * | toCopyFrom | ) |

inline protected

Definition at line 195 of file ICameraSceneNode.h.

References ICameraSceneNode(), and IsOrthogonal.

## deserializeAttributes()

virtual void irr::scene::ICameraSceneNode::deserializeAttributes | ( | io::IAttributes * | in,
|  | io::SAttributeReadWriteOptions * | options = 0 )

inline virtual

Reads attributes of the camera node.

Reimplemented from irr::scene::ISceneNode.

Definition at line 183 of file ICameraSceneNode.h.

References irr::scene::ISceneNode::deserializeAttributes(), irr::io::IAttributes::findAttribute(), irr::io::IAttributes::getAttributeAsBool(), and IsOrthogonal.

## getAspectRatio()

virtual f32 irr::scene::ICameraSceneNode::getAspectRatio | ( |  | ) | const

pure virtual

Gets the aspect ratio of the camera.

Returns
  The aspect ratio of the camera.

## getFarValue()

virtual f32 irr::scene::ICameraSceneNode::getFarValue | ( |  | ) | const

pure virtual

Gets the value of the far plane of the camera.

Returns
  The value of the far plane of the camera.

## getFOV()

virtual f32 irr::scene::ICameraSceneNode::getFOV | ( |  | ) | const

pure virtual

Gets the field of view of the camera.

Returns
  The field of view of the camera in radians.

## getNearValue()

virtual f32 irr::scene::ICameraSceneNode::getNearValue | ( |  | ) | const

pure virtual

Gets the value of the near plane of the camera.

Returns
  The value of the near plane of the camera.

## getProjectionMatrix()

virtual const core::matrix4 & irr::scene::ICameraSceneNode::getProjectionMatrix | ( |  | ) | const

pure virtual

Gets the current projection matrix of the camera.

Returns
  The current projection matrix of the camera.

## getTarget()

virtual const core::vector3df & irr::scene::ICameraSceneNode::getTarget | ( |  | ) | const

pure virtual

Gets the current look at target of the camera.

Returns
  The current look at target of the camera, in world co-ordinates

## getTargetAndRotationBinding()

virtual bool irr::scene::ICameraSceneNode::getTargetAndRotationBinding | ( | void |  | ) | const

pure virtual

Queries if the camera scene node's rotation and its target position are bound together.

See also
  bindTargetAndRotation()

## getUpVector()

virtual const core::vector3df & irr::scene::ICameraSceneNode::getUpVector | ( |  | ) | const

pure virtual

Gets the up vector of the camera.

Returns
  The up vector of the camera, in world space.

## getViewFrustum()

virtual const SViewFrustum * irr::scene::ICameraSceneNode::getViewFrustum | ( |  | ) | const

pure virtual

Get the view frustum.

Needed sometimes by bspTree or LOD render nodes.

Returns
  The current view frustum.

## getViewMatrix()

virtual const core::matrix4 & irr::scene::ICameraSceneNode::getViewMatrix | ( |  | ) | const

pure virtual

Gets the current view matrix of the camera.

Returns
  The current view matrix of the camera.

## getViewMatrixAffector()

virtual const core::matrix4 & irr::scene::ICameraSceneNode::getViewMatrixAffector | ( |  | ) | const

pure virtual

Get the custom view matrix affector.

Returns
  The affector matrix.

## isInputReceiverEnabled()

virtual bool irr::scene::ICameraSceneNode::isInputReceiverEnabled | ( |  | ) | const

pure virtual

Checks if the input receiver of the camera is currently enabled.

## isOrthogonal()

virtual bool irr::scene::ICameraSceneNode::isOrthogonal | ( |  | ) | const

inline virtual

Checks if a camera is orthogonal.

Definition at line 151 of file ICameraSceneNode.h.

References _IRR_IMPLEMENT_MANAGED_MARSHALLING_BUGFIX, and IsOrthogonal.

Referenced by setProjectionMatrix().

## OnEvent()

virtual bool irr::scene::ICameraSceneNode::OnEvent | ( | const SEvent & | event | ) |

pure virtual

It is possible to send mouse and key events to the camera.

Most cameras may ignore this input, but camera scene nodes which are created for example with ISceneManager::addCameraSceneNodeMaya or ISceneManager::addCameraSceneNodeFPS, may want to get this input for changing their position, look at target or whatever.

Implements irr::IEventReceiver.

## serializeAttributes()

virtual void irr::scene::ICameraSceneNode::serializeAttributes | ( | io::IAttributes * | out,
|  | io::SAttributeReadWriteOptions * | options = 0 ) const

inline virtual

Writes attributes of the camera node.

Reimplemented from irr::scene::ISceneNode.

Definition at line 173 of file ICameraSceneNode.h.

References irr::io::IAttributes::addBool(), IsOrthogonal, and irr::scene::ISceneNode::serializeAttributes().

## setAspectRatio()

virtual void irr::scene::ICameraSceneNode::setAspectRatio | ( | f32 | aspect | ) |

pure virtual

Sets the aspect ratio (default: 4.0f / 3.0f).

Parameters

  aspect | New aspect ratio.

## setFarValue()

virtual void irr::scene::ICameraSceneNode::setFarValue | ( | f32 | zf | ) |

pure virtual

Sets the value of the far clipping plane (default: 2000.0f).

Parameters

  zf | New z far value.

## setFOV()

virtual void irr::scene::ICameraSceneNode::setFOV | ( | f32 | fovy | ) |

pure virtual

Sets the field of view (Default: PI / 2.5f).

Parameters

  fovy | New field of view in radians.

## setInputReceiverEnabled()

virtual void irr::scene::ICameraSceneNode::setInputReceiverEnabled | ( | bool | enabled | ) |

pure virtual

Disables or enables the camera to get key or mouse inputs.

If this is set to true, the camera will respond to key inputs otherwise not.

## setNearValue()

virtual void irr::scene::ICameraSceneNode::setNearValue | ( | f32 | zn | ) |

pure virtual

Sets the value of the near clipping plane. (default: 1.0f).

Parameters

  zn | New z near value.

## setProjectionMatrix()

virtual void irr::scene::ICameraSceneNode::setProjectionMatrix | ( | const core::matrix4 & | projection,
|  | bool | isOrthogonal = false )

pure virtual

Sets the projection matrix of the camera.

The core::matrix4 class has some methods to build a projection matrix. e.g: core::matrix4::buildProjectionMatrixPerspectiveFovLH. Note that the matrix will only stay as set by this method until one of the following Methods are called: setNearValue, setFarValue, setAspectRatio, setFOV.

Parameters

  projection | The new projection matrix of the camera.
  isOrthogonal | Set this to true if the matrix is an orthogonal one (e.g. from matrix4::buildProjectionMatrixOrtho).

References isOrthogonal().

## setRotation()

virtual void irr::scene::ICameraSceneNode::setRotation | ( | const core::vector3df & | rotation | ) |

pure virtual

Sets the rotation of the node.

This only modifies the relative rotation of the node. If the camera's target and rotation are bound (

See also
  bindTargetAndRotation() ) then calling this will also change the camera's target to match the rotation.

Parameters

  rotation | New rotation of the node in degrees.

Reimplemented from irr::scene::ISceneNode.

## setTarget()

virtual void irr::scene::ICameraSceneNode::setTarget | ( | const core::vector3df & | pos | ) |

pure virtual

Sets the look at target of the camera.

If the camera's target and rotation are bound (

See also
  bindTargetAndRotation() ) then calling this will also change the camera's scene node rotation to match the target. Note that setTarget uses the current absolute position internally, so if you changed setPosition since last rendering you must call updateAbsolutePosition before using this function.

Parameters

  pos | Look at target of the camera, in world co-ordinates.

## setUpVector()

virtual void irr::scene::ICameraSceneNode::setUpVector | ( | const core::vector3df & | pos | ) |

pure virtual

Sets the up vector of the camera.

Parameters

  pos | New upvector of the camera.

## setViewMatrixAffector()

virtual void irr::scene::ICameraSceneNode::setViewMatrixAffector | ( | const core::matrix4 & | affector | ) |

pure virtual

Sets a custom view matrix affector.

The matrix passed here, will be multiplied with the view matrix when it gets updated. This allows for custom camera setups like, for example, a reflection camera.

Parameters

  affector | The affector matrix.

## Member Data Documentation

## IsOrthogonal

bool irr::scene::ICameraSceneNode::IsOrthogonal

protected

Definition at line 200 of file ICameraSceneNode.h.

Referenced by ICameraSceneNode(), cloneMembers(), deserializeAttributes(), isOrthogonal(), and serializeAttributes().

The documentation for this class was generated from the following file:

- ICameraSceneNode.h

- Irrlicht Engine Documentation © 2003-2012 by Nikolaus Gebhardt. Generated on for Irrlicht 3D Engine by Doxygen 1.15.0